<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="pt"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>JWTFilter.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Credenciamento</a> &gt; <a href="index.source.html" class="el_package">br.edu.unifacisa.lti.security.jwt</a> &gt; <span class="el_source">JWTFilter.java</span></div><h1>JWTFilter.java</h1><pre class="source lang-java linenums">package br.edu.unifacisa.lti.security.jwt;

import java.io.IOException;
import javax.servlet.*;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.util.StringUtils;
import org.springframework.web.filter.GenericFilterBean;

import io.jsonwebtoken.ExpiredJwtException;

/**
 * Filters incoming requests and installs a Spring Security principal if a header corresponding to a valid user is
 * found.
 */
public class JWTFilter extends GenericFilterBean {

<span class="fc" id="L23">    private final Logger log = LoggerFactory.getLogger(JWTFilter.class);</span>

    private TokenProvider tokenProvider;

<span class="fc" id="L27">    public JWTFilter(TokenProvider tokenProvider) {</span>
<span class="fc" id="L28">        this.tokenProvider = tokenProvider;</span>
<span class="fc" id="L29">    }</span>

    @Override
    public void doFilter(ServletRequest servletRequest, ServletResponse servletResponse, FilterChain filterChain)
        throws IOException, ServletException {
        try {
<span class="nc" id="L35">            HttpServletRequest httpServletRequest = (HttpServletRequest) servletRequest;</span>
<span class="nc" id="L36">            String jwt = resolveToken(httpServletRequest);</span>
<span class="nc bnc" id="L37" title="All 4 branches missed.">            if (StringUtils.hasText(jwt) &amp;&amp; this.tokenProvider.validateToken(jwt)) {</span>
<span class="nc" id="L38">                Authentication authentication = this.tokenProvider.getAuthentication(jwt);</span>
<span class="nc" id="L39">                SecurityContextHolder.getContext().setAuthentication(authentication);</span>
            }
<span class="nc" id="L41">            filterChain.doFilter(servletRequest, servletResponse);</span>
<span class="nc" id="L42">        } catch (ExpiredJwtException eje) {</span>
<span class="nc" id="L43">            log.info(&quot;Security exception for user {} - {}&quot;,</span>
<span class="nc" id="L44">                eje.getClaims().getSubject(), eje.getMessage());</span>

<span class="nc" id="L46">            log.trace(&quot;Security exception trace: {}&quot;, eje);</span>
<span class="nc" id="L47">            ((HttpServletResponse) servletResponse).setStatus(HttpServletResponse.SC_UNAUTHORIZED);</span>
<span class="nc" id="L48">        }</span>
<span class="nc" id="L49">    }</span>

    private String resolveToken(HttpServletRequest request){
<span class="nc" id="L52">        String bearerToken = request.getHeader(JWTConfigurer.AUTHORIZATION_HEADER);</span>
<span class="nc bnc" id="L53" title="All 4 branches missed.">        if (StringUtils.hasText(bearerToken) &amp;&amp; bearerToken.startsWith(&quot;Bearer &quot;)) {</span>
<span class="nc" id="L54">            return bearerToken.substring(7, bearerToken.length());</span>
        }
<span class="nc" id="L56">        return null;</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.7.9.201702052155</span></div></body></html>